<template>
  <Navbar />
  <SubNavbar />
  <div class="container">
    <div class="movie-list">
      <h1><span style="color:yellow">▏</span> Movies</h1>
      <p>Admin can delete, add, and edit the films that will be displayed.</p>

      <!-- Tambah movie -->
      <button id="add-movie" @click="showAddMovieForm = true">Tambah Movie</button>

      <div v-if="showAddMovieForm" class="modal">
        <div class="modal-content">
          <span @click="showAddMovieForm = false" class="close">&times;</span>
          <h2>Tambah Movie Baru</h2>
          <form @submit.prevent="addMovie">
            <table>
              <tr>
                <td><label for="title">Title:</label></td>
                <td><input type="text" v-model="newMovie.title" required /></td>
              </tr>
              <tr>
                <td><label for="director">Director:</label></td>
                <td><input type="text" v-model="newMovie.director" required /></td>
              </tr>
              <tr>
                <td><label for="release_year">Release Year:</label></td>
                <td><input type="number" v-model="newMovie.release_year" required /></td>
              </tr>
              <tr>
                <td><label for="genre">Genre:</label></td>
                <td><input type="text" v-model="newMovie.genre" required /></td>
              </tr>
              <tr>
                <td><label for="synopsis">Synopsis:</label></td>
                <td><textarea v-model="newMovie.synopsis" required></textarea></td>
              </tr>
              <tr>
                <td><label for="duration">Duration (minutes):</label></td>
                <td><input type="number" v-model="newMovie.duration" required /></td>
              </tr>
              <tr>
                <td><label for="min_rate">Minimum Rate:</label></td>
                <td><input type="text" v-model="newMovie.min_rate" required /></td>
              </tr>
              <tr>
                <td><label for="cover_image_url">Cover Image URL:</label></td>
                <td><input type="url" v-model="newMovie.cover_image_url" required /></td>
              </tr>
              <tr>
                <td><label for="trailer">Trailer URL:</label></td>
                <td><input type="url" v-model="newMovie.trailer" required /></td>
              </tr>
            </table>
            <button type="submit">Tambah</button>
          </form>
        </div>
      </div>


      <!-- Nampilin Movie -->
      <div class="row row-cols-3 row-cols-md-6 g-4">
        <div v-for="film in dataResponse" :key="film.id">
          <div class="card" style="width: 200px; background-color:#1F2937; color:#ffffff">
            <router-link :to="{ name: 'guest_detail', params: { id: film.id } }">
              <img :src="film.cover_image_url" :alt="film.title" style="width: 200px; height: 300px; padding:10px">
            </router-link>
            <div class="card-body">
              <h5 class="card-title">{{ film.title }}</h5>
              <p class="card-text" style="font-size:12px">
                {{ film.duration }} mnt • {{ film.genre }}
              </p>
            </div>
              <button style="margin: 5px 10px" @click="editMovieForm = true; selectedMovie = film">Edit Movie</button>
              <button style="margin: 5px 10px" @click="confirmDeleteMovie(film)">Delete Movie</button>
          </div>
          
        </div>
      </div>

      <!-- Edit Movie -->
      <div v-if="editMovieForm" class="modal">
        <div class="modal-content">
          <span @click="editMovieForm = false" class="close">&times;</span>
          <h2>Edit Movie</h2>
          <form @submit.prevent="updateMovie(selectedMovie.id)">
            <table>
              <tr>
                <td><label for="title">Title:</label></td>
                <td><input type="text" v-model="selectedMovie.title" required /></td>
              </tr>
              <tr>
                <td><label for="director">Director:</label></td>
                <td><input type="text" v-model="selectedMovie.director" required /></td>
              </tr>
              <tr>
                <td><label for="release_year">Release Year:</label></td>
                <td><input type="number" v-model="selectedMovie.release_year" required /></td>
              </tr>
              <tr>
                <td><label for="genre">Genre:</label></td>
                <td><input type="text" v-model="selectedMovie.genre" required /></td>
              </tr>
              <tr>
                <td><label for="synopsis">Synopsis:</label></td>
                <td><textarea v-model="selectedMovie.synopsis" required></textarea></td>
              </tr>
              <tr>
                <td><label for="duration">Duration (minutes):</label></td>
                <td><input type="number" v-model="selectedMovie.duration" required /></td>
              </tr>
              <tr>
                <td><label for="min_rate">Minimum Rate:</label></td>
                <td><input type="text" v-model="selectedMovie.min_rate" required /></td>
              </tr>
              <tr>
                <td><label for="cover_image_url">Cover Image URL:</label></td>
                <td><input type="url" v-model="selectedMovie.cover_image_url" required /></td>
              </tr>
              <tr>
                <td><label for="trailer">Trailer URL:</label></td>
                <td><input type="url" v-model="selectedMovie.trailer" required /></td>
              </tr>
            </table>
            <button type="submit">Update</button>
          </form>
        </div>
      </div>

      <!-- Delete Movie Confirmation -->
      <div v-if="deleteMovieForm" class="modal">
        <div class="modal-content">
          <span @click="deleteMovieForm = false" class="close">&times;</span>
          <h2>Confirm Delete</h2>
          <p>Are you sure you want to delete the movie "{{ selectedMovie.title }}"?</p>
          <button style="margin: 5px 10px;" @click="deleteMovie(selectedMovie.id)">Yes</button>
          <button style="margin: 5px 10px;" @click="deleteMovieForm = false">No</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Navbar from '@/components/Navbar.vue';
import SubNavbar from '@/components/SubNavbar.vue';
import axios from 'axios';
import { ref } from 'vue';

export default {
  name: 'AdminMovies',
  components: {
    Navbar, SubNavbar
  },
  setup() {
    const URL = 'http://localhost:8000';
    const dataResponse = ref([]);
    const showAddMovieForm = ref(false);
    const editMovieForm = ref(false);
    const deleteMovieForm = ref(false);
    const selectedMovie = ref(null);
    const newMovie = ref({
      title: '',
      director: '',
      release_year: '',
      genre: '',
      synopsis: '',
      duration: '',
      min_rate: '',
      cover_image_url: '',
      trailer: ''
    });

    async function fetchDatas() {
      try {
        const response = await axios.get(`${URL}/api/dashboard`);
        dataResponse.value = response.data.films;
      } catch (err) {
        console.error(err);
      }
    }

    async function addMovie() {
      try {
        const response = await axios.post(`${URL}/api/movie`, newMovie.value);
        dataResponse.value.push(response.data.film);
        showAddMovieForm.value = false;
        newMovie.value = {
          title: '',
          director: '',
          release_year: '',
          genre: '',
          synopsis: '',
          duration: '',
          min_rate: '',
          cover_image_url: '',
          trailer: ''
        };
      } catch (err) {
        console.error(err);
      }
    }

    async function updateMovie(id) {
      try {
        await axios.put(`${URL}/api/movie/${id}`, selectedMovie.value);
        editMovieForm.value = false;
        selectedMovie.value = null;
        fetchDatas();
      } catch (err) {
        console.error(err);
      }
    }

    async function deleteMovie(id) {
      try {
        await axios.delete(`${URL}/api/movieDelete/${id}`);
        dataResponse.value = dataResponse.value.filter(movie => movie.id !== id);
        deleteMovieForm.value = false;
        selectedMovie.value = null;
      } catch (err) {
        console.error(err);
      }
    }

    function confirmDeleteMovie(movie) {
      selectedMovie.value = movie;
      deleteMovieForm.value = true;
    }

    fetchDatas();

    return {
      dataResponse,
      showAddMovieForm,
      editMovieForm,
      deleteMovieForm,
      newMovie,
      selectedMovie,
      addMovie,
      updateMovie,
      deleteMovie,
      confirmDeleteMovie
    };
  }
};
</script>


<style>
body {
  background: #030814;
}

.container {
  color: white;
  padding: 20px;
}

.movie-list {
  margin: 20px 0px;
}

.card-title {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

button {
  margin-top: 10px;
  padding: 5px 10px;
  background-color: #8A2E2E;
  color: white;
  border: none;
  border-radius: 5px;
  cursor: pointer;
}

button:hover {
  background-color: #202938;
}

.modal {
  display: block;
  position: fixed;
  z-index: 1;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  overflow: auto;
  background-color: rgba(0, 0, 0, 0.5);
}

.modal-content {
  background-color: #202938;
  margin: 15% auto;
  padding: 20px;
  border: 1px solid #888;
  width: 50%;
  border-radius: 10px;
}

.close {
  color: #aaa;
  float: right;
  font-size: 28px;
  font-weight: bold;
}

.close:hover,
.close:focus {
  color: white;
  text-decoration: none;
  cursor: pointer;
}

#add-movie {
  margin-bottom: 20px;
  background-color: grey;
}
</style>
